# Client Server

Although not necessary, authentication and authorization are typically done between client and server. Here we look at ways clients can use Unfurl in this way. &#x20;

### Node.js

#### [express-openid-connect.js](https://github.com/auth0/express-openid-connect)

```javascript
const { auth } = require('express-openid-connect');
app.use(
  auth({
    issuerBaseURL: 'https://auth.unfurl-connect.com',
    baseURL: 'https://YOUR_APPLICATION_ROOT_URL',
    clientID: 'YOUR_CLIENT_ID',
    secret: '***********************',
    response_type: 'code',
    response_mode: 'form_post',
    scope: 'openid offline_access roles',
    claims: {
      id_token: {"roles": { "essential" : true } }
    }
  })
);
```

There is no client code. Logging in is done by navigating the user to `/login`.

A full example can be found [here](https://github.com/Unfurl-Connect/example-clients/tree/main/express-openid-connect).&#x20;


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.unfurl-connect.com/guides/easy-integration/client-server.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
